Index: trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/globals/VBoxGlobal.cpp	(revision 72174)
@@ -1160,5 +1160,4 @@
     QString strHomeFolder = fUseLastFolder && !strLastFolder.isEmpty() ? strLastFolder :
                             strDefaultFolder.isEmpty() ? vboxGlobal().homeFolder() : strDefaultFolder;
-
 
     /* Prepare filters and backends: */
@@ -4677,2 +4676,3 @@
     return true;
 }
+
Index: trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerFilterPanel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerFilterPanel.cpp	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/logviewer/UIVMLogViewerFilterPanel.cpp	(revision 72174)
@@ -32,4 +32,5 @@
 # include <QPlainTextEdit>
 # include <QTextCursor>
+# include <QToolButton>
 # include <QRadioButton>
 # include <QScrollArea>
@@ -78,5 +79,5 @@
     virtual void        mousePressEvent(QMouseEvent * event) /* override */;
     virtual void        mouseReleaseEvent(QMouseEvent *){}
-    virtual void        paintEvent(QPaintEvent *event) /* override */;
+    virtual void        paintEvent(QPaintEvent *event);
 
 private slots:
@@ -89,9 +90,9 @@
 private:
 
-    void          createButtons();
-    QIToolButton *m_pRemoveTermButton;
-    QIToolButton *m_pClearAllButton;
-    const int     m_iRemoveTermButtonSize;
-    int           m_iTrailingSpaceCount;
+    void         createButtons();
+    QToolButton *m_pRemoveTermButton;
+    QToolButton *m_pClearAllButton;
+    const int    m_iRemoveTermButtonSize;
+    int          m_iTrailingSpaceCount;
 };
 
@@ -196,10 +197,10 @@
     if (!m_pRemoveTermButton)
     {
-        m_pRemoveTermButton = new QIToolButton(this);
+        m_pRemoveTermButton = new QToolButton(this);
         if (m_pRemoveTermButton)
         {
             m_pRemoveTermButton->setIcon(m_pRemoveTermButton->style()->standardIcon(QStyle::SP_TitleBarCloseButton));
             m_pRemoveTermButton->hide();
-            connect(m_pRemoveTermButton, &QIToolButton::clicked, this, &UIVMFilterLineEdit::sltRemoveFilterTerm);
+            connect(m_pRemoveTermButton, &QToolButton::clicked, this, &UIVMFilterLineEdit::sltRemoveFilterTerm);
         }
     }
@@ -207,9 +208,9 @@
     if (!m_pClearAllButton)
     {
-        m_pClearAllButton = new QIToolButton(this);
+        m_pClearAllButton = new QToolButton(this);
         if (m_pClearAllButton)
         {
             m_pClearAllButton->setIcon(m_pClearAllButton->style()->standardIcon(QStyle::SP_LineEditClearButton));
-            connect(m_pClearAllButton, &QIToolButton::clicked, this, &UIVMFilterLineEdit::sltClearAll);
+            connect(m_pClearAllButton, &QToolButton::clicked, this, &UIVMFilterLineEdit::sltClearAll);
         }
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsGeneral.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsGeneral.cpp	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/machine/UIMachineSettingsGeneral.cpp	(revision 72174)
@@ -554,5 +554,5 @@
         {
             /* Configure widget: */
-            //m_pNameAndSystemEditor->nameEditor()->setValidator(new QRegExpValidator(QRegExp(".+"), this));
+            m_pNameAndSystemEditor->nameEditor()->setValidator(new QRegExpValidator(QRegExp(".+"), this));
         }
     }
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIApplianceEditorWidget.cpp	(revision 72174)
@@ -668,5 +668,5 @@
                    UIFilePathSelector *pFileChooser = new UIFilePathSelector(pParent);
                    pFileChooser->setMode(UIFilePathSelector::Mode_File_Save);
-                   pFileChooser->setResetEnabled(true);
+                   pFileChooser->setResetEnabled(false);
                    pEditor = pFileChooser;
                 break;
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.cpp	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.cpp	(revision 72174)
@@ -31,5 +31,4 @@
 # include "UIFilePathSelector.h"
 # include "UINameAndSystemEditor.h"
-# include "UIVMNamePathSelector.h"
 
 /* COM includes: */
@@ -51,9 +50,10 @@
     , m_fSupportsHWVirtEx(false)
     , m_fSupportsLongMode(false)
+    , m_pLabelName(0)
     , m_pLabelFamily(0)
     , m_pLabelType(0)
     , m_pIconType(0)
-    , m_pNamePathLabel(0)
-    , m_pNamePathSelector(0)
+    , m_pEditorName(0)
+    , m_pEditorLocation(0)
     , m_pComboFamily(0)
     , m_pComboType(0)
@@ -65,21 +65,16 @@
 QString UINameAndSystemEditor::name() const
 {
-    if (!m_pNamePathSelector)
-        return QString();
-    return m_pNamePathSelector->name();
-}
-
-QString UINameAndSystemEditor::path() const
-{
-    if (!m_pNamePathSelector)
-        return vboxGlobal().virtualBox().GetSystemProperties().GetDefaultMachineFolder();
-    return m_pNamePathSelector->path();
+    if (!m_fChooseLocation)
+        return m_pEditorName->text();
+    else
+        return m_pEditorLocation->path();
 }
 
 void UINameAndSystemEditor::setName(const QString &strName)
 {
-    if (!m_pNamePathSelector)
-        return;
-    m_pNamePathSelector->setName(strName);
+    if (!m_fChooseLocation)
+        m_pEditorName->setText(strName);
+    else
+        m_pEditorLocation->setPath(strName);
 }
 
@@ -117,8 +112,11 @@
 void UINameAndSystemEditor::retranslateUi()
 {
+    m_pLabelName->setText(tr("N&ame:"));
     m_pLabelFamily->setText(tr("&Type:"));
     m_pLabelType->setText(tr("&Version:"));
-    m_pNamePathLabel->setText(tr("Path/Name:"));
-
+    if (!m_fChooseLocation)
+        m_pEditorName->setWhatsThis(tr("Holds the name of the virtual machine."));
+    else
+        m_pEditorLocation->setWhatsThis(tr("Holds the location of the virtual machine."));
     m_pComboFamily->setWhatsThis(tr("Selects the operating system family that "
                                     "you plan to install into this virtual machine."));
@@ -229,16 +227,43 @@
         pMainLayout->setContentsMargins(0, 0, 0, 0);
 
-        m_pNamePathLabel = new QLabel;
-        if (m_pNamePathLabel)
-        {
-            m_pNamePathLabel->setAlignment(Qt::AlignRight);
-            m_pNamePathLabel->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
-            pMainLayout->addWidget(m_pNamePathLabel, 0, 0, 1, 1);
-        }
-        m_pNamePathSelector = new UIVMNamePathSelector;
-        if (m_pNamePathSelector)
-        {
-            m_pNamePathSelector->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
-            pMainLayout->addWidget(m_pNamePathSelector, 0, 1, 1, 2);
+        /* Create VM name label: */
+        m_pLabelName = new QLabel;
+        if (m_pLabelName)
+        {
+            /* Configure VM name label: */
+            m_pLabelName->setAlignment(Qt::AlignRight);
+            m_pLabelName->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
+            /* Add VM name label into main-layout: */
+            pMainLayout->addWidget(m_pLabelName, 0, 0);
+        }
+
+        if (!m_fChooseLocation)
+        {
+            /* Create VM name editor: */
+            m_pEditorName = new QLineEdit;
+            if (m_pEditorName)
+            {
+                /* Configure VM name editor: */
+                m_pEditorName->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
+                m_pLabelName->setBuddy(m_pEditorName);
+                /* Add VM name editor into main-layout: */
+                pMainLayout->addWidget(m_pEditorName, 0, 1, 1, 2);
+            }
+        }
+        else
+        {
+            /* Create VM location editor: */
+            m_pEditorLocation = new UIFilePathSelector;
+            if (m_pEditorLocation)
+            {
+                /* Configure advanced VM name editor: */
+                m_pEditorLocation->setResetEnabled(false);
+                m_pEditorLocation->setMode(UIFilePathSelector::Mode_File_Save);
+                m_pEditorLocation->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
+                m_pEditorLocation->setHomeDir(vboxGlobal().virtualBox().GetSystemProperties().GetDefaultMachineFolder());
+                m_pLabelName->setBuddy(m_pEditorLocation);
+                /* Add advanced VM name editor into main-layout: */
+                pMainLayout->addWidget(m_pEditorLocation, 0, 1, 1, 2);
+            }
         }
 
@@ -300,4 +325,5 @@
                 pLayoutIcon->addWidget(m_pIconType);
             }
+
             /* Add stretch to sub-layout: */
             pLayoutIcon->addStretch();
@@ -332,6 +358,10 @@
 {
     /* Prepare connections: */
-    connect(m_pNamePathSelector, &UIVMNamePathSelector::sigNameChanged,
-            this, &UINameAndSystemEditor::sigNameChanged);
+    if (!m_fChooseLocation)
+        connect(m_pEditorName, &QLineEdit::textChanged,
+                this, &UINameAndSystemEditor::sigNameChanged);
+    else
+        connect(m_pEditorLocation, &UIFilePathSelector::pathChanged,
+                this, &UINameAndSystemEditor::sigNameChanged);
     connect(m_pComboFamily, static_cast<void(QComboBox::*)(int)>(&QComboBox::currentIndexChanged),
             this, &UINameAndSystemEditor::sltFamilyChanged);
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.h	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.h	(revision 72174)
@@ -36,5 +36,4 @@
 class QString;
 class UIFilePathSelector;
-class UIVMNamePathSelector;
 
 /** QWidget subclass providing complex editor for basic VM parameters. */
@@ -59,9 +58,11 @@
     UINameAndSystemEditor(QWidget *pParent, bool fChooseLocation = false);
 
+    /** Returns the VM name editor. */
+    QLineEdit *nameEditor() const { return m_pEditorName; }
+    /** Returns the VM location editor. */
+    UIFilePathSelector *locationEditor() const { return m_pEditorLocation; }
+
     /** Returns the VM name. */
     QString name() const;
-    /** Returns path string selected by the user. */
-    QString path() const;
-
     /** Defines the VM @a strName. */
     void setName(const QString &strName);
@@ -85,5 +86,5 @@
     void sltTypeChanged(int iIndex);
 
- private:
+private:
 
     /** @name Prepare cascade.
@@ -112,4 +113,6 @@
     bool                    m_fSupportsLongMode;
 
+    /** Holds the VM name label instance. */
+    QLabel                 *m_pLabelName;
     /** Holds the VM OS family label instance. */
     QLabel                 *m_pLabelFamily;
@@ -118,7 +121,8 @@
     /** Holds the VM OS type icon instance. */
     QLabel                 *m_pIconType;
-
-    QLabel                 *m_pNamePathLabel;
-    UIVMNamePathSelector   *m_pNamePathSelector;
+    /** Holds the VM name editor instance. */
+    QLineEdit              *m_pEditorName;
+    /** Holds the VM location editor instance. */
+    UIFilePathSelector     *m_pEditorLocation;
     /** Holds the VM OS family combo instance. */
     QComboBox              *m_pComboFamily;
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIVMNamePathSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIVMNamePathSelector.cpp	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIVMNamePathSelector.cpp	(revision 72174)
@@ -25,9 +25,6 @@
 
 /* GUI includes: */
-# include "QIFileDialog.h"
 # include "QILineEdit.h"
 # include "QILabel.h"
-# include "QIToolButton.h"
-# include "UIIconPool.h"
 # include "UIVMNamePathSelector.h"
 # include "VBoxGlobal.h"
@@ -38,4 +35,6 @@
 #endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
 
+
+
 UIVMNamePathSelector::UIVMNamePathSelector(QWidget *pParent /* = 0 */)
     : QIWithRetranslateUI<QWidget>(pParent)
@@ -44,8 +43,6 @@
     , m_pName(0)
     , m_pSeparator(0)
-    ,m_pFileDialogButton(0)
 {
     prepareWidgets();
-    retranslateUi();
 }
 
@@ -55,5 +52,5 @@
     CVirtualBox vbox = vboxGlobal().virtualBox();
     /* Get default machine folder: */
-    return vbox.GetSystemProperties().GetDefaultMachineFolder();
+    /*const QString strDefaultMachineFolder = */return vbox.GetSystemProperties().GetDefaultMachineFolder();
 
 }
@@ -68,12 +65,4 @@
     m_pMainLayout->setSpacing(0);
     setLayout(m_pMainLayout);
-
-    m_pFileDialogButton = new QIToolButton(this);
-    if (m_pFileDialogButton)
-    {
-        m_pMainLayout->addWidget(m_pFileDialogButton);
-        m_pFileDialogButton->setIcon(UIIconPool::iconSet(QString(":/sf_add_16px.png")));
-        connect(m_pFileDialogButton, &QIToolButton::clicked, this, &UIVMNamePathSelector::sltOpenPathSelector);
-    }
 
     m_pPath = new QILineEdit;
@@ -95,7 +84,4 @@
     {
         m_pMainLayout->addWidget(m_pName);
-        connect(m_pName, &QILineEdit::textChanged,
-                this, &UIVMNamePathSelector::sigNameChanged);
-
     }
 
@@ -135,15 +121,3 @@
 void UIVMNamePathSelector::retranslateUi()
 {
-    setToolTip(tr("The Virtual Machine files will be saved under ..."));
 }
-
-void UIVMNamePathSelector::sltOpenPathSelector()
-{
-
-    QString strSelectedPath = QIFileDialog::getExistingDirectory(m_pPath->text(), this,
-                                                                 QString("Select a parent folder for new Virtual Machine"));
-    if (!strSelectedPath.isEmpty())
-    {
-        m_pPath->setText(strSelectedPath);
-    }
-}
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIVMNamePathSelector.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIVMNamePathSelector.h	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIVMNamePathSelector.h	(revision 72174)
@@ -29,5 +29,5 @@
 class QILabel;
 class QILineEdit;
-class QIToolButton;
+
 
 class SHARED_LIBRARY_STUFF UIVMNamePathSelector : public QIWithRetranslateUI<QWidget>
@@ -36,6 +36,4 @@
 
 signals:
-
-    void sigNameChanged(const QString &strName);
 
 public:
@@ -57,5 +55,4 @@
 private slots:
 
-    void sltOpenPathSelector();
 
 private:
@@ -68,6 +65,4 @@
     QILineEdit  *m_pName;
     QILabel     *m_pSeparator;
-    QIToolButton *m_pFileDialogButton;
-
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.cpp	(revision 72174)
@@ -25,14 +25,10 @@
 
 /* Local includes: */
-# include "QIRichTextLabel.h"
-# include "UIEmptyFilePathSelector.h"
-# include "UIFilePathSelector.h"
 # include "UIWizardImportAppPageBasic1.h"
 # include "UIWizardImportAppPageBasic2.h"
 # include "UIWizardImportApp.h"
 # include "VBoxGlobal.h"
-
-/* COM includes: */
-# include "CSystemProperties.h"
+# include "UIEmptyFilePathSelector.h"
+# include "QIRichTextLabel.h"
 
 #endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
@@ -58,22 +54,4 @@
         pMainLayout->addWidget(m_pLabel);
         pMainLayout->addWidget(m_pFileSelector);
-
-
-        m_pDefaultFolderLabel = new QIRichTextLabel(this);
-        if (m_pDefaultFolderLabel)
-        {
-            pMainLayout->addWidget(m_pDefaultFolderLabel);
-        }
-
-        m_pDestinationFolderSelector = new UIFilePathSelector(this);
-        if (m_pDestinationFolderSelector)
-        {
-            m_pDestinationFolderSelector->setMode(UIFilePathSelector::Mode_Folder);
-            pMainLayout->addWidget(m_pDestinationFolderSelector);
-
-            m_pDestinationFolderSelector->setPath(vboxGlobal().virtualBox().GetSystemProperties().GetDefaultMachineFolder());
-            m_pDestinationFolderSelector->setResetEnabled(false);
-        }
-
         pMainLayout->addStretch();
     }
@@ -92,5 +70,4 @@
                                             "saved in the Open Virtualization Format (OVF). "
                                             "To continue, select the file to import below.</p>"));
-    m_pDefaultFolderLabel->setText(UIWizardImportApp::tr("Select a destionation folder for appliance"));
     m_pFileSelector->setChooseButtonToolTip(UIWizardImportApp::tr("Choose a virtual appliance file to import..."));
     m_pFileSelector->setFileDialogTitle(UIWizardImportApp::tr("Please choose a virtual appliance file to import"));
@@ -130,2 +107,3 @@
     return pImportApplianceWidget->isValid();
 }
+
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/importappliance/UIWizardImportAppPageBasic1.h	(revision 72174)
@@ -24,5 +24,4 @@
 /* Forward declarations: */
 class UIEmptyFilePathSelector;
-class UIFilePathSelector;
 class QIRichTextLabel;
 
@@ -37,6 +36,4 @@
     /* Widgets: */
     UIEmptyFilePathSelector *m_pFileSelector;
-    QIRichTextLabel         *m_pDefaultFolderLabel;
-    UIFilePathSelector      *m_pDestinationFolderSelector;
 };
 
@@ -68,2 +65,3 @@
 
 #endif /* __UIWizardImportAppPageBasic1_h__ */
+
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.cpp	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.cpp	(revision 72174)
@@ -217,6 +217,4 @@
 bool UIWizardNewVMPage1::createMachineFolder()
 {
-    if (!m_pNameAndSystemEditor)
-        return false;
     /* Cleanup previosly created folder if any: */
     if (machineFolderCreated() && !cleanupMachineFolder())
@@ -229,11 +227,10 @@
     CVirtualBox vbox = vboxGlobal().virtualBox();
     /* Get default machine folder: */
-    //const QString strMachineFolder = vbox.GetSystemProperties().GetDefaultMachineFolder();
-
+    const QString strDefaultMachineFolder = vbox.GetSystemProperties().GetDefaultMachineFolder();
     /* Compose machine filename: */
     const QString strMachineFilePath = vbox.ComposeMachineFilename(m_pNameAndSystemEditor->name(),
                                                                    m_strGroup,
                                                                    QString(),
-                                                                   m_pNameAndSystemEditor->path());
+                                                                   strDefaultMachineFolder);
     /* Compose machine folder/basename: */
     const QFileInfo fileInfo(strMachineFilePath);
@@ -318,5 +315,5 @@
 
     /* Translate widgets: */
-    m_pLabel->setText(UIWizardNewVM::tr("Please choose a descriptive name and destination folder for the new virtual machine "
+    m_pLabel->setText(UIWizardNewVM::tr("Please choose a descriptive name for the new virtual machine "
                                         "and select the type of operating system you intend to install on it. "
                                         "The name you choose will be used throughout VirtualBox "
@@ -343,2 +340,3 @@
     return createMachineFolder();
 }
+
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.h	(revision 72173)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.h	(revision 72174)
@@ -58,8 +58,8 @@
     QString m_strMachineBaseName;
 
-    /** Provides a path selector and a line edit field for path and name entry. */
+    /* Widgets: */
     UINameAndSystemEditor *m_pNameAndSystemEditor;
 
-    /** Variables: */
+    /* Variables: */
     QString m_strGroup;
     bool m_fSupportsHWVirtEx;
@@ -107,2 +107,3 @@
 
 #endif // __UIWizardNewVMPageBasic1_h__
+