Index: trunk/src/VBox/VMM/Makefile.kmk
===================================================================
--- trunk/src/VBox/VMM/Makefile.kmk	(revision 72207)
+++ trunk/src/VBox/VMM/Makefile.kmk	(revision 72208)
@@ -49,9 +49,9 @@
  VMM_COMMON_DEFS += VBOX_WITH_3RD_IEM_STEP
 endif
-ifdef VBOX_WITH_NESTED_HWVIRT
- VMM_COMMON_DEFS += VBOX_WITH_NESTED_HWVIRT
- ifdef VBOX_WITH_NESTED_HWVIRT_ONLY_IN_IEM
-  VMM_COMMON_DEFS += VBOX_WITH_NESTED_HWVIRT_ONLY_IN_IEM
- endif
+ifdef VBOX_WITH_NESTED_HWVIRT_SVM
+ VMM_COMMON_DEFS += VBOX_WITH_NESTED_HWVIRT_SVM
+endif
+ifdef VBOX_WITH_NESTED_HWVIRT_ONLY_IN_IEM
+ VMM_COMMON_DEFS += VBOX_WITH_NESTED_HWVIRT_ONLY_IN_IEM
 endif
 #ifdef VBOX_WITH_IEM
@@ -570,5 +570,5 @@
  VMMRC_DEFS      = IN_VMM_RC IN_RT_RC IN_DIS DIS_CORE_ONLY VBOX_WITH_RAW_MODE VBOX_WITH_RAW_MODE_NOT_R0 IN_SUP_RC \
  	$(VMM_COMMON_DEFS)
- VMMRC_DEFS := $(filter-out VBOX_WITH_NESTED_HWVIRT,$(VMMRC_DEFS))
+ VMMRC_DEFS := $(filter-out VBOX_WITH_NESTED_HWVIRT_SVM,$(VMMRC_DEFS))
  ifdef VBOX_WITH_VMM_R0_SWITCH_STACK
   VMMRC_DEFS    += VMM_R0_SWITCH_STACK
Index: trunk/src/VBox/VMM/VMMAll/CPUMAllMsrs.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/CPUMAllMsrs.cpp	(revision 72207)
+++ trunk/src/VBox/VMM/VMMAll/CPUMAllMsrs.cpp	(revision 72208)
@@ -184,5 +184,5 @@
     RT_NOREF_PV(pVCpu); RT_NOREF_PV(idMsr); RT_NOREF_PV(pRange);
     *puValue = TMCpuTickGet(pVCpu);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     *puValue = CPUMApplyNestedGuestTscOffset(pVCpu, *puValue);
 #endif
@@ -345,5 +345,5 @@
      *        what we want? */
     *puValue = TMCpuTickGet(pVCpu);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     *puValue = CPUMApplyNestedGuestTscOffset(pVCpu, *puValue);
 #endif
@@ -368,5 +368,5 @@
      *        what we want? */
     *puValue = TMCpuTickGet(pVCpu);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     *puValue = CPUMApplyNestedGuestTscOffset(pVCpu, *puValue);
 #endif
@@ -4934,5 +4934,5 @@
 static DECLCALLBACK(VBOXSTRICTRC) cpumMsrRd_Gim(PVMCPU pVCpu, uint32_t idMsr, PCCPUMMSRRANGE pRange, uint64_t *puValue)
 {
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     /* Raise #GP(0) like a physical CPU would since the nested-hypervisor hasn't intercept these MSRs. */
     PCCPUMCTX pCtx = &pVCpu->cpum.s.Guest;
@@ -4947,5 +4947,5 @@
 static DECLCALLBACK(VBOXSTRICTRC) cpumMsrWr_Gim(PVMCPU pVCpu, uint32_t idMsr, PCCPUMMSRRANGE pRange, uint64_t uValue, uint64_t uRawValue)
 {
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     /* Raise #GP(0) like a physical CPU would since the nested-hypervisor hasn't intercept these MSRs. */
     PCCPUMCTX pCtx = &pVCpu->cpum.s.Guest;
Index: trunk/src/VBox/VMM/VMMAll/EMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/EMAll.cpp	(revision 72207)
+++ trunk/src/VBox/VMM/VMMAll/EMAll.cpp	(revision 72208)
@@ -1316,5 +1316,5 @@
 
     uint64_t uTicks = TMCpuTickGet(pVCpu);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     uTicks = CPUMApplyNestedGuestTscOffset(pVCpu, uTicks);
 #endif
@@ -1355,5 +1355,5 @@
 
     uint64_t uTicks = TMCpuTickGet(pVCpu);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     uTicks = CPUMApplyNestedGuestTscOffset(pVCpu, uTicks);
 #endif
Index: trunk/src/VBox/VMM/VMMR0/HMR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/HMR0.cpp	(revision 72207)
+++ trunk/src/VBox/VMM/VMMR0/HMR0.cpp	(revision 72208)
@@ -632,5 +632,5 @@
         g_HmR0.aCpuInfo[i].HCPhysMemObj = NIL_RTHCPHYS;
         g_HmR0.aCpuInfo[i].pvMemObj     = NULL;
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
         g_HmR0.aCpuInfo[i].n.svm.hNstGstMsrpm      = NIL_RTR0MEMOBJ;
         g_HmR0.aCpuInfo[i].n.svm.HCPhysNstGstMsrpm = NIL_RTHCPHYS;
@@ -790,5 +790,5 @@
                 g_HmR0.aCpuInfo[i].pvMemObj     = NULL;
             }
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
             if (g_HmR0.aCpuInfo[i].n.svm.hNstGstMsrpm != NIL_RTR0MEMOBJ)
             {
@@ -944,5 +944,5 @@
         Assert(!g_HmR0.aCpuInfo[i].cTlbFlushes);
         Assert(!g_HmR0.aCpuInfo[i].uCurrentAsid);
-# ifdef VBOX_WITH_NESTED_HWVIRT
+# ifdef VBOX_WITH_NESTED_HWVIRT_SVM
         Assert(g_HmR0.aCpuInfo[i].n.svm.hNstGstMsrpm      == NIL_RTR0MEMOBJ);
         Assert(g_HmR0.aCpuInfo[i].n.svm.HCPhysNstGstMsrpm == NIL_RTHCPHYS);
@@ -978,5 +978,5 @@
         {
             Assert(g_HmR0.aCpuInfo[i].hMemObj == NIL_RTR0MEMOBJ);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
             Assert(g_HmR0.aCpuInfo[i].n.svm.hNstGstMsrpm == NIL_RTR0MEMOBJ);
 #endif
@@ -995,5 +995,5 @@
                 ASMMemZeroPage(g_HmR0.aCpuInfo[i].pvMemObj);
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
                 rc = RTR0MemObjAllocCont(&g_HmR0.aCpuInfo[i].n.svm.hNstGstMsrpm, SVM_MSRPM_PAGES << X86_PAGE_4K_SHIFT,
                                          false /* executable R0 mapping */);
Index: trunk/src/VBox/VMM/VMMR0/HMSVMR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/HMSVMR0.cpp	(revision 72207)
+++ trunk/src/VBox/VMM/VMMR0/HMSVMR0.cpp	(revision 72208)
@@ -59,5 +59,5 @@
         } while (0)
 
-# ifdef VBOX_WITH_NESTED_HWVIRT
+# ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 #  define HMSVM_NESTED_EXITCODE_STAM_COUNTER_INC(u64ExitCode) do { \
         STAM_COUNTER_INC(&pVCpu->hm.s.StatExitAll); \
@@ -70,5 +70,5 @@
 #else
 # define HMSVM_EXITCODE_STAM_COUNTER_INC(u64ExitCode)           do { } while (0)
-# ifdef VBOX_WITH_NESTED_HWVIRT
+# ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 #  define HMSVM_NESTED_EXITCODE_STAM_COUNTER_INC(u64ExitCode)   do { } while (0)
 # endif
@@ -83,5 +83,5 @@
  * \#VMEXIT intercepts that maybe caused during delivering of another
  * event in the guest. */
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 # define HMSVM_CHECK_EXIT_DUE_TO_EVENT_DELIVERY() \
     do \
@@ -139,5 +139,5 @@
 
 /** Assert that we're not executing a nested-guest. */
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 # define HMSVM_ASSERT_NOT_IN_NESTED_GUEST(a_pCtx)       Assert(!CPUMIsGuestInSvmNestedHwVirtMode((a_pCtx)))
 #else
@@ -146,5 +146,5 @@
 
 /** Assert that we're executing a nested-guest. */
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 # define HMSVM_ASSERT_IN_NESTED_GUEST(a_pCtx)           Assert(CPUMIsGuestInSvmNestedHwVirtMode((a_pCtx)))
 #else
@@ -370,8 +370,8 @@
 static FNSVMEXITHANDLER hmR0SvmExitXcptAC;
 static FNSVMEXITHANDLER hmR0SvmExitXcptBP;
-#if defined(HMSVM_ALWAYS_TRAP_ALL_XCPTS) || defined(VBOX_WITH_NESTED_HWVIRT)
+#if defined(HMSVM_ALWAYS_TRAP_ALL_XCPTS) || defined(VBOX_WITH_NESTED_HWVIRT_SVM)
 static FNSVMEXITHANDLER hmR0SvmExitXcptGeneric;
 #endif
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 static FNSVMEXITHANDLER hmR0SvmExitXcptPFNested;
 static FNSVMEXITHANDLER hmR0SvmExitClgi;
@@ -387,5 +387,5 @@
 
 static int hmR0SvmHandleExit(PVMCPU pVCpu, PCPUMCTX pMixedCtx, PSVMTRANSIENT pSvmTransient);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 static int hmR0SvmHandleExitNested(PVMCPU pVCpu, PCPUMCTX pCtx, PSVMTRANSIENT pSvmTransient);
 #endif
@@ -757,5 +757,5 @@
 {
     PVM pVM = pVCpu->CTX_SUFF(pVM);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     if (CPUMIsGuestInSvmNestedHwVirtMode(pCtx))
     {
@@ -780,5 +780,5 @@
 {
     PVM pVM = pVCpu->CTX_SUFF(pVM);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     if (CPUMIsGuestInSvmNestedHwVirtMode(pCtx))
     {
@@ -803,5 +803,5 @@
 {
     PVM pVM = pVCpu->CTX_SUFF(pVM);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     if (CPUMIsGuestInSvmNestedHwVirtMode(pCtx))
     {
@@ -847,5 +847,5 @@
         if (!fInNestedGuestMode)
             *pbMsrBitmap &= ~RT_BIT(uMsrpmBit);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
         else
         {
@@ -867,5 +867,5 @@
         if (!fInNestedGuestMode)
             *pbMsrBitmap &= ~RT_BIT(uMsrpmBit + 1);
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
         else
         {
@@ -903,5 +903,5 @@
     bool const fUseLbrVirt           = fLbrVirt; /** @todo CFGM, IEM implementation etc. */
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     bool const fVirtVmsaveVmload     = RT_BOOL(pVM->hm.s.svm.u32Features & X86_CPUID_SVM_FEATURE_EDX_VIRT_VMSAVE_VMLOAD);
     bool const fUseVirtVmsaveVmload  = fVirtVmsaveVmload && pVM->hm.s.svm.fVirtVmsaveVmload && pVM->hm.s.fNestedPaging;
@@ -953,5 +953,5 @@
 #endif
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     /* Virtualized VMSAVE/VMLOAD. */
     pVmcbCtrl->LbrVirt.n.u1VirtVmsaveVmload = fUseVirtVmsaveVmload;
@@ -1087,5 +1087,5 @@
 DECLINLINE(PSVMVMCB) hmR0SvmGetCurrentVmcb(PVMCPU pVCpu, PCPUMCTX pCtx)
 {
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     if (CPUMIsGuestInSvmNestedHwVirtMode(pCtx))
         return pCtx->hwvirt.svm.CTX_SUFF(pVmcb);
@@ -1106,5 +1106,5 @@
 DECLINLINE(PSVMNESTEDVMCBCACHE) hmR0SvmGetNestedVmcbCache(PVMCPU pVCpu, PCPUMCTX pCtx)
 {
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     Assert(pCtx->hwvirt.svm.fHMCachedVmcb); RT_NOREF(pCtx);
     return &pVCpu->hm.s.svm.NstGstVmcbCache;
@@ -1165,5 +1165,5 @@
 static void hmR0SvmFlushTaggedTlb(PVMCPU pVCpu, PCPUMCTX pCtx, PSVMVMCB pVmcb, PHMGLOBALCPUINFO pHostCpu)
 {
-#ifndef VBOX_WITH_NESTED_HWVIRT
+#ifndef VBOX_WITH_NESTED_HWVIRT_SVM
     RT_NOREF(pCtx);
 #endif
@@ -1184,5 +1184,5 @@
     if (   pVCpu->hm.s.idLastCpu   != pHostCpu->idCpu
         || pVCpu->hm.s.cTlbFlushes != pHostCpu->cTlbFlushes
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
         || CPUMIsGuestInSvmNestedHwVirtMode(pCtx)
 #endif
@@ -1411,5 +1411,5 @@
     {
         bool fRemove = true;
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
         /* Only remove the intercept if the nested-guest is also not intercepting it! */
         if (CPUMIsGuestInSvmNestedHwVirtMode(pCtx))
@@ -1467,5 +1467,5 @@
     {
         bool fRemove = true;
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
         /* Only remove the control intercept if the nested-guest is also not intercepting it! */
         if (CPUMIsGuestInSvmNestedHwVirtMode(pCtx))
@@ -1989,5 +1989,5 @@
 
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * Loads the nested-guest APIC state (currently just the TPR).
@@ -2146,5 +2146,5 @@
 
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * Merges guest and nested-guest intercepts for executing the nested-guest using
@@ -2406,5 +2406,5 @@
     pVmcb->guest.u64RAX    = pCtx->rax;
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     if (pVmcb->ctrl.IntCtrl.n.u1VGifEnable)
     {
@@ -2449,5 +2449,5 @@
 
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * Merges the guest and nested-guest MSR permission bitmap.
@@ -2628,5 +2628,5 @@
     pVmcbNstGst->guest.u64RAX    = pCtx->rax;
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     Assert(!pVmcbNstGst->ctrl.IntCtrl.n.u1VGifEnable);            /* Nested VGIF not supported yet. */
 #endif
@@ -2660,5 +2660,5 @@
     return rc;
 }
-#endif /* VBOX_WITH_NESTED_HWVIRT */
+#endif /* VBOX_WITH_NESTED_HWVIRT_SVM */
 
 
@@ -2731,5 +2731,5 @@
 
     PCSVMVMCBCTRL pVmcbCtrl = &pVmcb->ctrl;
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     if (!CPUMIsGuestInSvmNestedHwVirtMode(pMixedCtx))
     {
@@ -3495,5 +3495,5 @@
      * VINTR intercept all being set.
      */
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     /*
      * Currently we don't overlay interupt windows and if there's any V_IRQ pending
@@ -3547,5 +3547,5 @@
 }
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * Evaluates the event to be delivered to the nested-guest and sets it as the
@@ -3679,5 +3679,5 @@
     Assert(pVmcb);
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     bool const fGif       = pCtx->hwvirt.fGif;
 #else
@@ -4099,5 +4099,5 @@
 
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * Does the preparations before executing nested-guest code in AMD-V.
@@ -4120,5 +4120,5 @@
     HMSVM_ASSERT_IN_NESTED_GUEST(pCtx);
 
-#ifdef VBOX_WITH_NESTED_HWVIRT_ONLY_IN_IEM
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM_ONLY_IN_IEM
     Log2(("hmR0SvmPreRunGuest: Rescheduling to IEM due to nested-hwvirt or forced IEM exec -> VINF_EM_RESCHEDULE_REM\n"));
     return VINF_EM_RESCHEDULE_REM;
@@ -4468,5 +4468,5 @@
 
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * Undoes the TSC offset applied for an SVM nested-guest and returns the TSC
@@ -4790,5 +4790,5 @@
 }
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * Runs the nested-guest code using AMD-V.
@@ -4899,5 +4899,5 @@
     uint32_t cLoops = 0;
     int      rc;
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     if (!CPUMIsGuestInSvmNestedHwVirtMode(pCtx))
 #endif
@@ -4908,5 +4908,5 @@
             rc = hmR0SvmRunGuestCodeStep(pVM, pVCpu, pCtx, &cLoops);
     }
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     else
     {
@@ -4937,5 +4937,5 @@
 
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * Determines whether an IOIO intercept is active for the nested-guest or not.
@@ -5554,5 +5554,5 @@
                 }
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
                 case SVM_EXIT_CLGI:     return hmR0SvmExitClgi(pVCpu, pCtx, pSvmTransient);
                 case SVM_EXIT_STGI:     return hmR0SvmExitStgi(pVCpu, pCtx, pSvmTransient);
@@ -6121,5 +6121,5 @@
 
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * Gets the length of the current instruction if the CPU supports the NRIP_SAVE
@@ -7544,5 +7544,5 @@
 
 
-#if defined(HMSVM_ALWAYS_TRAP_ALL_XCPTS) || defined(VBOX_WITH_NESTED_HWVIRT)
+#if defined(HMSVM_ALWAYS_TRAP_ALL_XCPTS) || defined(VBOX_WITH_NESTED_HWVIRT_SVM)
 /**
  * \#VMEXIT handler for generic exceptions. Conditional \#VMEXIT.
@@ -7588,5 +7588,5 @@
 #endif
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * \#VMEXIT handler for #PF occuring while in nested-guest execution
@@ -7824,5 +7824,5 @@
 }
 
-#endif /* VBOX_WITH_NESTED_HWVIRT */
+#endif /* VBOX_WITH_NESTED_HWVIRT_SVM */
 
 
Index: trunk/src/VBox/VMM/VMMR3/CPUMR3CpuId.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/CPUMR3CpuId.cpp	(revision 72207)
+++ trunk/src/VBox/VMM/VMMR3/CPUMR3CpuId.cpp	(revision 72208)
@@ -3933,5 +3933,5 @@
     AssertLogRelRCReturn(rc, rc);
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     /** @cfgm{/CPUM/NestedHWVirt, bool, false}
      * Whether to expose the hardware virtualization (VMX/SVM) feature to the guest.
Index: trunk/src/VBox/VMM/VMMR3/EM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/EM.cpp	(revision 72207)
+++ trunk/src/VBox/VMM/VMMR3/EM.cpp	(revision 72208)
@@ -1656,5 +1656,5 @@
 }
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
 /**
  * Helper for emR3ForcedActions() for injecting interrupts into the
@@ -2077,5 +2077,5 @@
                 Assert(!HMR3IsEventPending(pVCpu));
                 PCPUMCTX pCtx = pVCpu->em.s.pCtx;
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
                 if (CPUMIsGuestInNestedHwVirtMode(pCtx))
                 {
@@ -2096,5 +2096,5 @@
                 {
                     if (   VMCPU_FF_IS_PENDING(pVCpu, VMCPU_FF_INTERRUPT_APIC | VMCPU_FF_INTERRUPT_PIC)
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
                         && pCtx->hwvirt.fGif
 #endif
Index: trunk/src/VBox/VMM/VMMR3/HM.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 72207)
+++ trunk/src/VBox/VMM/VMMR3/HM.cpp	(revision 72208)
@@ -1085,5 +1085,5 @@
 # endif
 
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
         /*
          * Nested-guest Exit reason stats.
Index: trunk/src/VBox/VMM/include/EMHandleRCTmpl.h
===================================================================
--- trunk/src/VBox/VMM/include/EMHandleRCTmpl.h	(revision 72207)
+++ trunk/src/VBox/VMM/include/EMHandleRCTmpl.h	(revision 72208)
@@ -248,5 +248,5 @@
              * we still need to implement hypercalls rather than throw a #UD.
              */
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
             if (pVM->cpum.ro.GuestFeatures.fSvm)
             {
Index: trunk/src/VBox/VMM/include/HMInternal.h
===================================================================
--- trunk/src/VBox/VMM/include/HMInternal.h	(revision 72207)
+++ trunk/src/VBox/VMM/include/HMInternal.h	(revision 72208)
@@ -286,5 +286,5 @@
     /** In use by our code. (for power suspend) */
     volatile bool       fInUse;
-#ifdef VBOX_WITH_NESTED_HWVIRT
+#ifdef VBOX_WITH_NESTED_HWVIRT_SVM
     /** Nested-guest union (put data common to SVM/VMX outside the union). */
     union