Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.cpp	(revision 72271)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.cpp	(revision 72279)
@@ -176,4 +176,18 @@
 }
 
+void UIFilePathSelector::setDefaultPath(const QString &strDefaultPath)
+{
+    if (m_strDefaultPath == strDefaultPath)
+        return;
+    m_strDefaultPath = strDefaultPath;
+    if (currentIndex() == ResetId)
+        setPath(m_strDefaultPath);
+}
+
+const QString& UIFilePathSelector::defaultPath() const
+{
+    return m_strDefaultPath;
+}
+
 void UIFilePathSelector::setPath(const QString &strPath, bool fRefreshText /* = true */)
 {
@@ -321,5 +335,8 @@
         case ResetId:
         {
-            changePath(QString::null);
+            if (m_strDefaultPath.isEmpty())
+                changePath(QString::null);
+            else
+                changePath(m_strDefaultPath);
             break;
         }
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.h	(revision 72271)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIFilePathSelector.h	(revision 72279)
@@ -112,4 +112,7 @@
     void setToolTip(const QString &strToolTip);
 
+    void setDefaultPath(const QString &strDefaultPath);
+    const QString& defaultPath() const;
+
 public slots:
 
@@ -204,4 +207,7 @@
     /** Holds the copy action instance. */
     QAction *m_pCopyAction;
+
+    /** Path is set to m_strDefaultPath when it is reset. */
+    QString m_strDefaultPath;
 };
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.cpp	(revision 72271)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.cpp	(revision 72279)
@@ -24,12 +24,11 @@
 # include <QGridLayout>
 # include <QLabel>
-# include <QLineEdit>
 # include <QVBoxLayout>
 
 /* GUI includes: */
+# include "QILineEdit.h"
 # include "VBoxGlobal.h"
 # include "UIFilePathSelector.h"
 # include "UINameAndSystemEditor.h"
-# include "UIVMNamePathSelector.h"
 
 /* COM includes: */
@@ -54,6 +53,8 @@
     , m_pLabelType(0)
     , m_pIconType(0)
-    , m_pNamePathLabel(0)
-    , m_pNamePathSelector(0)
+    , m_pNameLabel(0)
+    , m_pPathLabel(0)
+    , m_pNameLineEdit(0)
+    , m_pPathSelector(0)
     , m_pComboFamily(0)
     , m_pComboType(0)
@@ -65,21 +66,21 @@
 QString UINameAndSystemEditor::name() const
 {
-    if (!m_pNamePathSelector)
+    if (!m_pNameLineEdit)
         return QString();
-    return m_pNamePathSelector->name();
+    return m_pNameLineEdit->text();
 }
 
 QString UINameAndSystemEditor::path() const
 {
-    if (!m_pNamePathSelector)
+    if (!m_pPathSelector)
         return vboxGlobal().virtualBox().GetSystemProperties().GetDefaultMachineFolder();
-    return m_pNamePathSelector->path();
+    return m_pPathSelector->path();
 }
 
 void UINameAndSystemEditor::setName(const QString &strName)
 {
-    if (!m_pNamePathSelector)
+    if (!m_pNameLineEdit)
         return;
-    m_pNamePathSelector->setName(strName);
+    m_pNameLineEdit->setText(strName);
 }
 
@@ -119,5 +120,6 @@
     m_pLabelFamily->setText(tr("&Type:"));
     m_pLabelType->setText(tr("&Version:"));
-    m_pNamePathLabel->setText(tr("Path/Name:"));
+    m_pNameLabel->setText(tr("Name:"));
+    m_pPathLabel->setText(tr("Path:"));
 
     m_pComboFamily->setWhatsThis(tr("Selects the operating system family that "
@@ -229,18 +231,31 @@
         pMainLayout->setContentsMargins(0, 0, 0, 0);
 
-        m_pNamePathLabel = new QLabel;
-        if (m_pNamePathLabel)
-        {
-            m_pNamePathLabel->setAlignment(Qt::AlignRight);
-            m_pNamePathLabel->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
-            pMainLayout->addWidget(m_pNamePathLabel, 0, 0, 1, 1);
-        }
-        m_pNamePathSelector = new UIVMNamePathSelector;
-        if (m_pNamePathSelector)
-        {
-            m_pNamePathSelector->setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
-            m_pNamePathSelector->setPath(vboxGlobal().virtualBox().GetSystemProperties().GetDefaultMachineFolder());
-            pMainLayout->addWidget(m_pNamePathSelector, 0, 1, 1, 2);
-            setFocusProxy(m_pNamePathSelector);
+        m_pNameLabel = new QLabel;
+        if (m_pNameLabel)
+        {
+            m_pNameLabel->setAlignment(Qt::AlignRight);
+            m_pNameLabel->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
+            pMainLayout->addWidget(m_pNameLabel, 0, 0, 1, 1);
+        }
+        m_pNameLineEdit = new QILineEdit;
+        if (m_pNameLineEdit)
+        {
+            pMainLayout->addWidget(m_pNameLineEdit, 0, 1, 1, 1);
+        }
+
+        m_pPathLabel = new QLabel;
+        if (m_pPathLabel)
+        {
+            m_pPathLabel->setAlignment(Qt::AlignRight);
+            pMainLayout->addWidget(m_pPathLabel, 1, 0, 1, 1);
+        }
+
+        m_pPathSelector = new UIFilePathSelector;
+        if (m_pPathSelector)
+        {
+            pMainLayout->addWidget(m_pPathSelector, 1, 1, 1, 1);
+            QString strDefaultMachineFolder = vboxGlobal().virtualBox().GetSystemProperties().GetDefaultMachineFolder();
+            m_pPathSelector->setPath(strDefaultMachineFolder);
+            m_pPathSelector->setDefaultPath(strDefaultMachineFolder);
         }
 
@@ -253,5 +268,5 @@
             m_pLabelFamily->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
             /* Add VM OS family label into main-layout: */
-            pMainLayout->addWidget(m_pLabelFamily, 1, 0);
+            pMainLayout->addWidget(m_pLabelFamily, 2, 0);
         }
 
@@ -264,5 +279,5 @@
             m_pLabelFamily->setBuddy(m_pComboFamily);
             /* Add VM OS family combo into main-layout: */
-            pMainLayout->addWidget(m_pComboFamily, 1, 1);
+            pMainLayout->addWidget(m_pComboFamily, 2, 1);
         }
 
@@ -275,5 +290,5 @@
             m_pLabelType->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
             /* Add VM OS type label into main-layout: */
-            pMainLayout->addWidget(m_pLabelType, 2, 0);
+            pMainLayout->addWidget(m_pLabelType, 3, 0);
         }
 
@@ -286,5 +301,5 @@
             m_pLabelType->setBuddy(m_pComboType);
             /* Add VM OS type combo into main-layout: */
-            pMainLayout->addWidget(m_pComboType, 2, 1);
+            pMainLayout->addWidget(m_pComboType, 3, 1);
         }
 
@@ -305,5 +320,5 @@
             pLayoutIcon->addStretch();
             /* Add sub-layout into main-layout: */
-            pMainLayout->addLayout(pLayoutIcon, 1, 2, 2, 1);
+            pMainLayout->addLayout(pLayoutIcon, 2, 2, 2, 1);
         }
     }
@@ -334,7 +349,7 @@
 {
     /* Prepare connections: */
-    connect(m_pNamePathSelector, &UIVMNamePathSelector::sigNameChanged,
+    connect(m_pNameLineEdit, &QILineEdit::textChanged,
             this, &UINameAndSystemEditor::sigNameChanged);
-    connect(m_pNamePathSelector, &UIVMNamePathSelector::sigPathChanged,
+    connect(m_pPathSelector, &UIFilePathSelector::pathChanged,
             this, &UINameAndSystemEditor::sigPathChanged);
     connect(m_pComboFamily, static_cast<void(QComboBox::*)(int)>(&QComboBox::currentIndexChanged),
@@ -346,13 +361,6 @@
 void UINameAndSystemEditor::setNameFieldValidator(const QString &strValidatorString)
 {
-    if (!m_pNamePathSelector)
+    if (!m_pNameLineEdit)
         return;
-    m_pNamePathSelector->setNameFieldValidator(strValidatorString);
-}
-
-void UINameAndSystemEditor::setMachineFolder(const QString &strPath)
-{
-    if (!m_pNamePathSelector)
-        return;
-    m_pNamePathSelector->setToolTipText(strPath);
-}
+    m_pNameLineEdit->setValidator(new QRegExpValidator(QRegExp(strValidatorString), this));
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.h	(revision 72271)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UINameAndSystemEditor.h	(revision 72279)
@@ -33,8 +33,7 @@
 class QComboBox;
 class QLabel;
-class QLineEdit;
+class QILineEdit;
 class QString;
 class UIFilePathSelector;
-class UIVMNamePathSelector;
 
 /** QWidget subclass providing complex editor for basic VM parameters. */
@@ -74,7 +73,4 @@
 
     void setNameFieldValidator(const QString &strValidatorString);
-
-    /** Forwards the machine name to UIVMNamePathSelector member instance. */
-    void setMachineFolder(const QString &strPath);
 
 protected:
@@ -125,6 +121,8 @@
     QLabel                 *m_pIconType;
 
-    QLabel                 *m_pNamePathLabel;
-    UIVMNamePathSelector   *m_pNamePathSelector;
+    QLabel                 *m_pNameLabel;
+    QLabel                 *m_pPathLabel;
+    QILineEdit             *m_pNameLineEdit;
+    UIFilePathSelector     *m_pPathSelector;
     /** Holds the VM OS family combo instance. */
     QComboBox              *m_pComboFamily;
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.cpp	(revision 72271)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/newvm/UIWizardNewVMPageBasic1.cpp	(revision 72279)
@@ -234,7 +234,4 @@
     m_strMachineFolder = fileInfo.absolutePath();
     m_strMachineBaseName = fileInfo.completeBaseName();
-
-    if (m_pNameAndSystemEditor)
-        m_pNameAndSystemEditor->setMachineFolder(m_strMachineFolder);
 }
 