Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 72288)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 72289)
@@ -894,5 +894,4 @@
 	src/widgets/UIStatusBarEditorWindow.h \
 	src/widgets/UIToolBar.h \
-	src/widgets/UIVMNamePathSelector.h \
 	src/widgets/UIWarningPane.h \
 	src/wizards/UIWizard.h \
@@ -1121,5 +1120,4 @@
 	src/widgets/UIStatusBarEditorWindow.h \
 	src/widgets/UIToolBar.h \
-	src/widgets/UIVMNamePathSelector.h \
 	src/widgets/UIWarningPane.h \
 	src/wizards/UIWizard.h \
@@ -1202,6 +1200,5 @@
 	src/widgets/UIPortForwardingTable.cpp \
 	src/widgets/UIProgressDialog.cpp \
-	src/widgets/UIStatusBarEditorWindow.cpp \
-	src/widgets/UIVMNamePathSelector.cpp
+	src/widgets/UIStatusBarEditorWindow.cpp
 
  ifdef VBOX_GUI_WITH_NETWORK_MANAGER
@@ -1274,6 +1271,5 @@
 	src/widgets/UIPortForwardingTable.cpp \
 	src/widgets/UIProgressDialog.cpp \
-	src/widgets/UIStatusBarEditorWindow.cpp \
-	src/widgets/UIVMNamePathSelector.cpp
+	src/widgets/UIStatusBarEditorWindow.cpp
 
  ifdef VBOX_GUI_WITH_NETWORK_MANAGER
@@ -1573,5 +1569,4 @@
 	src/widgets/UIStatusBarEditorWindow.cpp \
 	src/widgets/UIToolBar.cpp \
-	src/widgets/UIVMNamePathSelector.cpp \
 	src/widgets/UIWarningPane.cpp \
 	src/wizards/UIWizard.cpp \
@@ -1857,5 +1852,4 @@
 	src/widgets/UIStatusBarEditorWindow.cpp \
 	src/widgets/UIToolBar.cpp \
-	src/widgets/UIVMNamePathSelector.cpp \
 	src/widgets/UIWarningPane.cpp \
 	src/wizards/UIWizard.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIVMNamePathSelector.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIVMNamePathSelector.cpp	(revision 72288)
+++ 	(revision )
@@ -1,265 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIVMNamePathSelector class implementation.
- */
-
-/*
- * Copyright (C) 2008-2018 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifdef VBOX_WITH_PRECOMPILED_HEADERS
-# include <precomp.h>
-#else  /* !VBOX_WITH_PRECOMPILED_HEADERS */
-
-/* Qt includes: */
-# include <QFontMetrics>
-# include <QDir>
-# include <QHBoxLayout>
-# include <QRegExpValidator>
-# include <QStyle>
-
-/* GUI includes: */
-# include "QIFileDialog.h"
-# include "QILineEdit.h"
-# include "QILabel.h"
-# include "QIToolButton.h"
-# include "UIIconPool.h"
-# include "UIVMNamePathSelector.h"
-# include "VBoxGlobal.h"
-
-/* COM includes: */
-# include "CSystemProperties.h"
-
-#endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
-
-const float UIVMNamePathSelector::s_fPathLabelWidthWeight = 0.65f;
-
-
-/*********************************************************************************************************************************
-*   UIPathLabel definition.                                                                                                      *
-*********************************************************************************************************************************/
-/** A QLabel extension used to display long texts in a single line with ellipses (if necessary). The client passes
- * a maximum width the label can have. If the original text is wider than it is compacted */
-class UIPathLabel : public QLabel
-{
-
-    Q_OBJECT;
-
-public:
-
-    UIPathLabel(QWidget *parent = 0);
-
-    int  maxWidth() const;
-    void setMaxWidth(int width);
-    void setText(const QString &text) /* override */;
-
-private:
-
-    /** Compact the text so that the label is not wider than maxWidth */
-    void compactText();
-
-    int     m_maxWidth;
-    QString m_strOriginalText;
-};
-
-
-/*********************************************************************************************************************************
-*   UIPathLabel implemetation.                                                                                                   *
-*********************************************************************************************************************************/
-
-UIPathLabel::UIPathLabel(QWidget *parent /* = 0*/)
-    :QLabel(parent)
-    , m_maxWidth(0)
-{
-}
-
-void UIPathLabel::compactText()
-{
-    QFontMetrics fontMetrics = this->fontMetrics();
-    QString strCompactedText = fontMetrics.elidedText(m_strOriginalText, Qt::ElideMiddle, m_maxWidth);
-    QLabel::setText(strCompactedText);
-}
-
-int UIPathLabel::maxWidth() const
-{
-    return m_maxWidth;
-}
-
-void UIPathLabel::setMaxWidth(int width)
-{
-    if (m_maxWidth == width)
-        return;
-    m_maxWidth = width;
-    compactText();
-}
-
-void UIPathLabel::setText(const QString &text)
-{
-    if (m_strOriginalText == text)
-        return;
-
-    m_strOriginalText = text;
-    compactText();
-}
-
-
-/*********************************************************************************************************************************
-*   UIVMNamePathSelector implemetation.                                                                                          *
-*********************************************************************************************************************************/
-
-UIVMNamePathSelector::UIVMNamePathSelector(QWidget *pParent /* = 0 */)
-    : QIWithRetranslateUI<QWidget>(pParent)
-    , m_pMainLayout(0)
-    , m_pPath(0)
-    , m_pName(0)
-    ,m_pFileDialogButton(0)
-{
-    prepareWidgets();
-    retranslateUi();
-}
-
-QString UIVMNamePathSelector::defaultMachineFolder() const
-{
-    /* Get VBox: */
-    CVirtualBox vbox = vboxGlobal().virtualBox();
-    /* Get default machine folder: */
-    return vbox.GetSystemProperties().GetDefaultMachineFolder();
-
-}
-
-void UIVMNamePathSelector::prepareWidgets()
-{
-    m_pMainLayout = new QHBoxLayout;
-    if (!m_pMainLayout)
-        return;
-    /* Configure layout: */
-    m_pMainLayout->setContentsMargins(0, 0, 0, 0);
-#ifdef VBOX_WS_MAC
-    m_pMainLayout->setSpacing(0);
-#else
-    m_pMainLayout->setSpacing(qApp->style()->pixelMetric(QStyle::PM_LayoutHorizontalSpacing) / 2);
-#endif
-    setLayout(m_pMainLayout);
-
-    m_pFileDialogButton = new QIToolButton(this);
-    if (m_pFileDialogButton)
-    {
-        m_pMainLayout->addWidget(m_pFileDialogButton);
-        m_pFileDialogButton->setIcon(UIIconPool::iconSet(QString(":/select_file_16px.png")));
-        connect(m_pFileDialogButton, &QIToolButton::clicked, this, &UIVMNamePathSelector::sltOpenPathSelector);
-    }
-
-    m_pPath = new UIPathLabel;
-    if (m_pPath)
-    {
-        m_pMainLayout->addWidget(m_pPath);
-        setPath(defaultMachineFolder());
-        m_pPath->setSizePolicy(QSizePolicy::Fixed, QSizePolicy::Fixed);
-    }
-
-    m_pName = new QILineEdit;
-    if (m_pName)
-    {
-        m_pMainLayout->addWidget(m_pName);
-        connect(m_pName, &QILineEdit::textChanged,
-                this, &UIVMNamePathSelector::sigNameChanged);
-        setFocusProxy(m_pName);
-        if (m_pFileDialogButton)
-            m_pFileDialogButton->setFocusProxy(m_pName);
-    }
-}
-
-QString UIVMNamePathSelector::path() const
-{
-    return m_strNonNativePath;
-}
-
-void UIVMNamePathSelector::setPath(const QString &path)
-{
-    if (m_strNonNativePath == path)
-        return;
-    m_strNonNativePath = path;
-
-    if (m_pPath)
-    {
-        QString nativePath(QDir::toNativeSeparators(path));
-        /** make sure we have a trailing seperator */
-        if (!nativePath.isEmpty() && !nativePath.endsWith(QDir::toNativeSeparators("/")))
-            nativePath += QDir::toNativeSeparators("/");
-        m_pPath->setText(nativePath);
-    }
-    emit sigPathChanged(m_strNonNativePath);
-}
-
-QString UIVMNamePathSelector::name() const
-{
-    if (!m_pName)
-        return QString();
-    return m_pName->text();
-}
-
-void UIVMNamePathSelector::setName(const QString &name)
-{
-    if (!m_pName && m_pName->text() == name)
-        return;
-    m_pName->setText(name);
-}
-
-void UIVMNamePathSelector::retranslateUi()
-{
-    if (m_strToolTipText.isEmpty())
-    {
-        setToolTip(tr("You have to enter a name for the virtual machine"));
-        return;
-    }
-    QString strToolTip = "The Virtual Machine files will be saved under " + m_strToolTipText;
-    setToolTip(tr(qPrintable(strToolTip)));
-}
-
-void UIVMNamePathSelector::resizeEvent(QResizeEvent *pEvent)
-{
-    QWidget::resizeEvent(pEvent);
-
-    if (m_pPath)
-        m_pPath->setMaxWidth(s_fPathLabelWidthWeight * width());
-}
-
-void UIVMNamePathSelector::sltOpenPathSelector()
-{
-    QString strSelectedPath = QIFileDialog::getExistingDirectory(m_strNonNativePath, this,
-                                                                 QString("Select a parent folder for new Virtual Machine"));
-    if (!strSelectedPath.isEmpty())
-    {
-        setPath(strSelectedPath);
-    }
-}
-
-void UIVMNamePathSelector::setNameFieldValidator(const QString &strValidatorString)
-{
-    if (!m_pName)
-        return;
-    m_pName->setValidator(new QRegExpValidator(QRegExp(strValidatorString), this));
-}
-
-void UIVMNamePathSelector::setToolTipText(const QString &strToolTipText)
-{
-    if (m_strToolTipText == strToolTipText)
-        return;
-    m_strToolTipText = QDir::toNativeSeparators(strToolTipText);
-    retranslateUi();
-}
-
-const QString& UIVMNamePathSelector::toolTipText() const
-{
-    return m_strToolTipText;
-}
-
-#include "UIVMNamePathSelector.moc"
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIVMNamePathSelector.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIVMNamePathSelector.h	(revision 72288)
+++ 	(revision )
@@ -1,85 +1,0 @@
-/* $Id$ */
-/** @file
- * VBox Qt GUI - UIVMNamePathSelector class declaration.
- */
-
-/*
- * Copyright (C) 2008-2018 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifndef ___UIVMNamePathSelector_h___
-#define ___UIVMNamePathSelector_h___
-
-/* Qt includes: */
-#include <QLineEdit>
-
-/* GUI includes: */
-#include "QIWithRetranslateUI.h"
-
-/* Forward declarations: */
-class QHBoxLayout;
-class QILineEdit;
-class QIToolButton;
-class UIPathLabel;
-
-class SHARED_LIBRARY_STUFF UIVMNamePathSelector : public QIWithRetranslateUI<QWidget>
-{
-    Q_OBJECT;
-
-signals:
-
-    void sigNameChanged(const QString &strName);
-    void sigPathChanged(const QString &strName);
-
-public:
-
-    UIVMNamePathSelector(QWidget *pParent = 0);
-
-public slots:
-
-    QString        path() const;
-    void           setPath(const QString &path);
-
-    QString        name() const;
-    void           setName(const QString &name);
-    void           setNameFieldValidator(const QString &strValidatorString);
-
-    void           setToolTipText(const QString &strToolTipText);
-    const QString& toolTipText() const;
-
-protected:
-
-    void retranslateUi() /* override */;
-    virtual void resizeEvent(QResizeEvent *pEvent) /* override */;
-
-private slots:
-
-    void sltOpenPathSelector();
-
-private:
-
-    void          prepareWidgets();
-    QString       defaultMachineFolder() const;
-
-    QHBoxLayout  *m_pMainLayout;
-    UIPathLabel  *m_pPath;
-    QILineEdit   *m_pName;
-    QIToolButton *m_pFileDialogButton;
-    /** Tooltip set is set by clients of this widget. */
-    QString       m_strToolTipText;
-    /** Path string whose separators are not converted to native ones. */
-    QString       m_strNonNativePath;
-    /** This widget's width is multiplied with this weight to compute max.
-     * width the path label can have */
-    static const float s_fPathLabelWidthWeight;
-};
-
-#endif /* !___UIVMNamePathSelector_h___ */